////////////////////////////////////////////////////////////////////////////////
///                            GL_NormalRenderer.h                           ///
////////////////////////////////////////////////////////////////////////////////

#ifndef GLNORMALRENDERER_H
#define GLNORMALRENDERER_H

#include "GL_NormalRendererStateVariables.h"

#include <X3DTK/gl_scenegraph.h>

namespace X3DTK {
namespace GL {

/// GL_NormalRenderer module.

class NormalRenderer : public X3DOnePassProcessor
{
public:
  /// Constructor.
  NormalRenderer();
  /// Destructor.
  virtual ~NormalRenderer();
  
  /// Sets the length of the normals.
  void setNormalLength(float value);
    
  /// Renders a GLScene.
  virtual void render(SFNode N) const;

protected:
  NormalRendererStateVariables *stateVariables;
};

}
}

#endif
