#include "NormalX3DGLScene.h"

namespace X3DTK {

NormalX3DGLScene::NormalX3DGLScene()
: SimpleX3DGLScene(), _normalRenderer(X3DProcessor::getInstanceOf<GL::NormalRenderer>()), _normal(false)
{
}

NormalX3DGLScene::~NormalX3DGLScene()
{
}

void NormalX3DGLScene::setNormal(bool value)
{
  _normal = value;
}

void NormalX3DGLScene::setNormalLength(float value)
{
  _normalRenderer->setNormalLength(value);
}

void NormalX3DGLScene::draw()
{
  // call to the super class draw method.
  SimpleX3DGLScene::draw();
  // Second pass rendering for the normals.
  if (_normal)
    _normalRenderer->render(glscene);
}

}
