////////////////////////////////////////////////////////////////////////////////
///                            X3D_Icosahedron.h                             ///
////////////////////////////////////////////////////////////////////////////////

#ifndef ICOSAHEDRON_H
#define ICOSAHEDRON_H

#include <X3DTK/x3d_scenegraph.h>

namespace X3DTK {
namespace X3D {

class Icosahedron : public X3DGeometry3DNode
{
public:
  // Constructor.
  Icosahedron();
  // Constructs an Icosahedron from its attributes.
  Icosahedron(SFFloat radius);
            
  // Clones the node.
  virtual SFNode clone() const;  
  // sets the radius.
  void setRadius(const SFFloat &radius);

  // gets the radius.
  inline const SFFloat &getRadius() const {return _radius;};
  
  // Loads the attributes from a X3DFileElement.
  virtual void load(const X3DFileElement *element);
  // Writes the attributes of the node.
  virtual SFString write() const;

protected:
  // Copy constructor.	   
  Icosahedron(const Icosahedron &I);

private:
  SFFloat _radius;
};

}
}

#endif
