#include "MESH_TransformComputerStateVariables.h"

namespace X3DTK {
namespace MESH {

MeshTransformComputerStateVariables::MeshTransformComputerStateVariables()
: StateVariables()
{
}

MeshTransformComputerStateVariables::~MeshTransformComputerStateVariables()
{
}

void MeshTransformComputerStateVariables::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

void MeshTransformComputerStateVariables::finish()
{
  _matrixStack.clear();
}

void MeshTransformComputerStateVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void MeshTransformComputerStateVariables::popMatrix()
{
  _matrixStack.pop_front();
}

}
}
