#include "MESH_TransformComputer.h"

#include <X3DTK/x3d_scenegraph.h>
#include <X3DTK/x3d_meshbuilder.h>

#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: meshtransformcomputer input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = X3DLoader::getInstanceOf<X3D::Loader>();
  // Instanciation of the new MeshBuilder.
  X3D::MeshBuilder *meshbuilder = X3DProcessor::getInstanceOf<X3D::MeshBuilder>();
  // Instanciation of the new MeshTransformComputer.
  MESH::MeshTransformComputer *mtc = X3DProcessor::getInstanceOf<MESH::MeshTransformComputer>();  
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], false);
  MESH::Scene *ms = meshbuilder->build(s);
  
  // Prints the scene.
  mtc->print(ms);  
  
  // removes all instances.
  X3DProcessor::removeAllInstances();  
  X3DLoader::removeInstanceOf<X3D::Loader>();
    
  return 1;
}
