/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_InlineLoaderNetworkingVisitor.h             //
////////////////////////////////////////////////////////////////////////////////

#ifndef INLINELOADERNETWORKINGVISITOR_H
#define INLINELOADERNETWORKINGVISITOR_H

#include "X3D_NetworkingVisitor.h"
#include "X3D_InlineLoaderStateVariables.h"

namespace X3DTK {
namespace X3D {

class Inline;

/// Visitor for the Texturing component of the GLBuilder module.

class InlineLoaderNetworkingVisitor : public NetworkingVisitor
{
public:
  /// Constructor.
  InlineLoaderNetworkingVisitor();
  /// Destructor.
  virtual ~InlineLoaderNetworkingVisitor();

  /// Enters an Inline.
  virtual void enterInline(Inline *I) const;

  /// Leaves a Inline.
  virtual void leaveInline(Inline *I) const;
  
protected:
  InlineLoaderStateVariables *stateVariables;
};

}
}

#endif
