#include "GL_RendererGroupingVisitor.h"
#include "GL_Group.h"
#include "GL_StaticGroup.h"
#include "GL_Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

RendererGroupingVisitor::RendererGroupingVisitor()
: GroupingVisitor()
{
  defineEnterFunction(&RendererGroupingVisitor::enterTransform);
  defineLeaveFunction(&RendererGroupingVisitor::leaveTransform);

  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<RendererStateVariables>();
}

RendererGroupingVisitor::~RendererGroupingVisitor()
{
}

void RendererGroupingVisitor::enterTransform(Transform *T) const
{
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMultMatrixf(&T->getTransformMatrix().front());
}

void RendererGroupingVisitor::leaveTransform(Transform *) const
{
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix(); 
}

}
}
