/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            GL_RendererGroupingVisitor.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLRENDERERGROUPINGVISITOR_H
#define GLRENDERERGROUPINGVISITOR_H

#include "GL_GroupingVisitor.h"
#include "GL_RendererStateVariables.h"

namespace X3DTK {
namespace GL {

class Transform;

/// Visitor for the GLGrouping component of the GLRenderer module.

class RendererGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  RendererGroupingVisitor();
  /// Destructor.
  virtual ~RendererGroupingVisitor();

  /// Enters a Transform.
  virtual void enterTransform(Transform *T) const;
  /// Leaves a Transform.
  virtual void leaveTransform(Transform *) const;

protected:
  RendererStateVariables *stateVariables;
};

}
}

#endif
