#include "MESH_MeshFacesDrawerStateVariables.h"
#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshFacesDrawerStateVariables::MeshFacesDrawerStateVariables()
: StateVariables(), _selectionMode(false), _oneColorPerMesh(true)
{}

void MeshFacesDrawerStateVariables::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

void MeshFacesDrawerStateVariables::finish()
{
  _matrixStack.pop_front();
  if (_matrixStack.size() != 0)
  {
    cx3d << "MeshFacesDrawerStateVariables::finishTraversal: Non empty matrix stack at the end of MeshFacesDrawer traversal" << endl;
    _matrixStack.clear();
  }
  
  _matrixVector.clear();
  _meshVector.clear();
}

void MeshFacesDrawerStateVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void MeshFacesDrawerStateVariables::popMatrix()
{
  _matrixStack.pop_front();
}

void MeshFacesDrawerStateVariables::storeMesh(Mesh *mesh)
{
  _matrixVector.push_back(_matrixStack.front());
  _meshVector.push_back(mesh);
}

int MeshFacesDrawerStateVariables::getCurrentMeshId()
{
  return _matrixVector.size() - 1;
}

}
}
