#include "MESH_MeshNormalUpdater.h"
#include "MESH_MeshNormalUpdaterFacesCoreVisitor.h"
#include "MESH_MeshNormalUpdaterVerticesCoreVisitor.h"
#include "MESH_DFSGraphTraversal.h"
#include "MESH_X3DNode.h"

namespace X3DTK {
namespace MESH {

MeshNormalUpdater::MeshNormalUpdater()
: X3DMultiPassProcessor()
{
  graphTraversalMap["Faces"] = new DFSGraphTraversal();
  graphTraversalMap["Vertices"] = new DFSGraphTraversal();
  
  graphTraversalMap["Faces"]->setComponentVisitor(new MeshNormalUpdaterFacesCoreVisitor());
  graphTraversalMap["Vertices"]->setComponentVisitor(new MeshNormalUpdaterVerticesCoreVisitor());
}

MeshNormalUpdater::~MeshNormalUpdater()
{
  for (MGraphTraversal::iterator it = graphTraversalMap.begin(); it != graphTraversalMap.end(); ++it)
    delete (*it).second;
}

void MeshNormalUpdater::updateNormals(X3DNode *N)
{
  graphTraversalMap["Faces"]->traverse(N);
  graphTraversalMap["Vertices"]->traverse(N);
}

} 
}
