#include "MESH_MeshVerticesDrawer.h"
#include "MESH_DFSGraphTraversal.h"
#include "MESH_MeshVerticesDrawerCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshVerticesDrawer::MeshVerticesDrawer()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<MeshVerticesDrawerStateVariables>();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MeshVerticesDrawerCoreVisitor());
}

MeshVerticesDrawer::~MeshVerticesDrawer()
{
  GraphTraversal::removeInstanceOf<MeshVerticesDrawerStateVariables>();
  
  delete graphTraversal;
}

void MeshVerticesDrawer::draw(X3DNode *N, bool selection)
{
  stateVariables->setSelectionMode(selection);
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

}
}

