#include "MESH_MeshX3DBuilder.h"
#include "MESH_MeshX3DBuilderCoreVisitor.h"
#include "MESH_DFSGraphTraversal.h"
#include "MESH_X3DNode.h"
#include "MESH_Scene.h"
#include "X3D_Scene.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshX3DBuilder::MeshX3DBuilder()
: X3DOnePassProcessor()
{
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MeshX3DBuilderCoreVisitor());
  
  stateVariables = GraphTraversal::getInstanceOf<MeshX3DBuilderStateVariables>();
}

MeshX3DBuilder::~MeshX3DBuilder()
{
  GraphTraversal::removeInstanceOf<MeshX3DBuilderStateVariables>();
  delete graphTraversal;
}

X3D::SFNode MeshX3DBuilder::build(SFNode N)
{
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
  
  return stateVariables->getRoot();
}

X3D::Scene *MeshX3DBuilder::build(Scene *S)
{
  return static_cast<X3D::Scene *>(build(static_cast<SFNode>(S)));
}

} 
}
