#include "X3D_SceneSaverCoreVisitor.h"
#include "X3D_Scene.h"
#include "X3D_X3DNode.h"
#include "X3DTypesToSFString.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

SceneSaverCoreVisitor::SceneSaverCoreVisitor()
: CoreVisitor()
{
  // Enter functions.
  defineEnterFunction(&SceneSaverCoreVisitor::enterX3DNode);

  // Walk on functions.
  defineWalkOnFunction(&SceneSaverCoreVisitor::walkOnX3DNode);

  // Leave functions.
  defineLeaveFunction(&SceneSaverCoreVisitor::leaveX3DNode);

  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<SceneSaverStateVariables>();
}

SceneSaverCoreVisitor::~SceneSaverCoreVisitor()
{
}

void SceneSaverCoreVisitor::enterX3DNode(X3DNode *N) const
{
  SFString attr;
  SFString USE = stateVariables->getUSE(N);

  stateVariables->newLine();
  stateVariables->pushCurrentLine();  
  SFString &currentLine = stateVariables->getCurrentLine();
  
  if (USE != "")
  {
    stateVariables->pushHasUSE(true);
    currentLine += "<" + N->getTypeName() + USE;
  }
  else
  {
    stateVariables->pushHasUSE(false);    
    currentLine += "<" + N->getTypeName() + stateVariables->getDEF(N);
    N->write(currentLine);    
  } 

  stateVariables->addTab();
}

bool SceneSaverCoreVisitor::walkOnX3DNode(X3DNode *, SFAbstractNode) const
{
  //return true;
  return !(stateVariables->getHasUSE());  
}

void SceneSaverCoreVisitor::leaveX3DNode(X3DNode *N) const
{
  stateVariables->removeTab();
  
  if (stateVariables->hasChild())
    stateVariables->getOpeningLine() += "/>";  
  else
  {
    stateVariables->getOpeningLine() += ">";
    stateVariables->newLine();
    stateVariables->getCurrentLine() += "</" + N->getTypeName() + ">";
  }  
  
  stateVariables->popLine();
  stateVariables->popHasUSE();  
}

}
}
