/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_TemplateMeshBuilderCoreVisitor.h            //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERCOREVISITOR_H
#define TEMPLATEMESHBUILDERCOREVISITOR_H

#include "X3D_CoreVisitor.h"
#include "X3D_TemplateMeshBuilderStateVariables.h"

namespace X3DTK {
namespace X3D {

class Scene;
class X3DNode;

/// Visitor for the Core component of the TemplateMeshBuilder processor.

class TemplateMeshBuilderCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderCoreVisitor();
  
  /// Destructor.
  virtual ~TemplateMeshBuilderCoreVisitor();
    
  /// Enters a Scene.
  virtual void enterScene(Scene *S) const;
  /// Enters an X3DNode.
  virtual void enterX3DNode(X3DNode *N) const;

  /// Walks on an X3DNode.
  virtual bool walkOnX3DNode(X3DNode *N, SFAbstractNode child) const;
  
  /// Enters a Scene.
  virtual void leaveX3DNode(X3DNode *N) const;

protected:
  TemplateMeshBuilderStateVariables *stateVariables;
};

}
}

#endif
