#include "MESH_MemReleaserCoreVisitor.h"
#include "MESH_X3DGroupingNode.h"
#include "MESH_X3DMeshNode.h"
#include "X3D_X3DAppearanceNode.h"

using namespace std;

namespace X3DTK {
namespace MESH {

MemReleaserCoreVisitor::MemReleaserCoreVisitor()
{
  defineEnterFunction(&MemReleaserCoreVisitor::enterX3DMeshNode);
  defineEnterFunction(&MemReleaserCoreVisitor::enterX3DGroupingNode);
}

void MemReleaserCoreVisitor::enterX3DGroupingNode(X3DGroupingNode *N) const
{
  MemReleaser *memReleaser = X3DProcessor::getInstanceOf<MemReleaser>();
  X3D::MFNode children = N->getX3DNodeChildren();
  for (X3D::MFNode::iterator it = children.begin(); it != children.end(); ++it)
    memReleaser->release(*it);
}

void MemReleaserCoreVisitor::enterX3DMeshNode(X3DMeshNode *N) const
{
  X3DProcessor::getInstanceOf<MemReleaser>()->release(N->getX3DAppearanceNodeChild());
}

} 
} 
